/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

/******************************** G E N E R  **************************************/

int intent_type (str)
{
	char *intent = U_str_copy_upper (str);

	if (!strcmp (intent, "IN"))
		return INTENT_IN;
	else if (!strcmp (intent, "OUT"))
		return INTENT_OUT;
	else if (!strcmp (intent, "INOUT"))
		return INTENT_INOUT;
	else
		return -1;
}

/******************************** Y A C C   **************************************/

yacc_IntentStmt (node)
Node *node;
{
	if (intent_type (node->IntentStmt.Name->com.str) < 0)
		fatal ("INTENT specification must be IN, OUT or INOUT");
}

/******************************** C H E C K **************************************/

intent_set (name, intent)
char *name;
int intent;
{
	T_Entry *entry = install_loc (name, TAB_INSTALL, 0);

	if (IS_intent_in (entry) || IS_intent_out (entry)) {
		sprintf (serr, "INTENT for '%s' already set", name);
		fatal (serr);
		return;
	}

	switch (intent) {

	case INTENT_IN:
		SET_intent_in (entry);
		break;

	case INTENT_OUT:
		SET_intent_out (entry);
		break;

	case INTENT_INOUT:
		SET_intent_inout (entry);
		break;
	}
}

Node *check_IntentStmt (node)
Node *node;
{
	int intent;
	Node *Nname, *temp;

	intent = intent_type (node->IntentStmt.Name->com.str);

	for (LIST_LOOP (Nname, node->IntentStmt.NameList, temp))
		intent_set (Nname->com.str, intent);
}

/******************************** T R A N S **************************************/

Node *trans_IntentStmt (node)
Node *node;
{
	return NN;
}

/******************************** W R I T E **************************************/
